define(['require', 'app'],
    function(require, APP) {
        /**
         * Controller for MiCuenta generated by Appery.io
         * @module MiCuenta
         */
        APP.controller('MiCuenta', ['$scope', 'Apperyio', controller]);

        function controller($scope, Apperyio) {
            /**
             * user controller variables
             */
            $scope.usuarios = Apperyio.EntityAPI('UserList');
            $scope.usuario = Apperyio.EntityAPI('User');
            /**
             * User controller functions
             */
            /**
             * @function init
             */
            $scope.init = function() {
                //On load screen logic
                $scope.usuario = JSON.parse(localStorage.getItem("userData"));
            };
            /**
             * @function actualizaDatosUsuario
             */
            $scope.actualizaDatosUsuario = function() {
                if ($scope.usuario.fullName === "") {
                    alert("El campo Nombre no puede ser vacío");
                    return;
                }
                if ($scope.usuario.newPassword) {
                    if ($scope.usuario.newPassword.length < 6) {
                        $scope.mAlert("La password debe tener al menos 6 caracteres");
                        return;
                    } else {
                        if ($scope.usuario.newPassword != $scope.usuario.newRePassword) {
                            $scope.mAlert("La password reingresada no coincide");
                            return
                        }
                    }
                }
                $scope.showLoading("Actualizando Datos...");
                var requestData = {};
                requestData = (function mapping6625($scope) {
                    var requestData = {};
                    requestData.headers = {};
                    requestData.data = {};
                    requestData.params = {};
                    var usuario_scope = $scope.usuario;
                    requestData.headers['X-Appery-Session-Token'] = usuario_scope.token;
                    _.set(requestData.data, 'fullName', usuario_scope.fullName);
                    if ($scope.usuario.newPassword) {
                        _.set(requestData.data, 'password', usuario_scope.newPassword);
                    }
                    requestData.params._id = usuario_scope._id;
                    return requestData;
                    /*|button_mapping|onbeforesend|0571C458-CEAB-7261-3CCF-4F4C9C255F0C||6625|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_user_update_service")(requestData).then( /*|service_bookmark|bookmark|0571C458-CEAB-7261-3CCF-4F4C9C255F0C||1732|*/
                    function(success) { // success callback
                        /*|button_mapping|onsuccess|0571C458-CEAB-7261-3CCF-4F4C9C255F0C||7783|*/
                        if ($scope.usuario.newPassword) {
                            $scope.stopLoading();
                            localStorage.clear();
                            sessionStorage.clear();
                            $scope.mAlert("Deberá ingresar nuevamente al sistema");
                            $scope.salir();
                        } else {
                            $scope.stopLoading();
                        }
                    },
                    function(error) { // callback to handle request error
                        alert("Hubo problemas al actualizar los datos: " + error.data.code + " " + error.data.description);
                        $scope.stopLoading();
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
        }
    });